<?php

namespace app\controllers;

use app\models\Country;
use app\models\EntryForm;
use yii\web\Response;
use yii\widgets\ActiveForm;

class TestController extends AppController
{

    public function actionIndex($name = 'Guest', $age = 25)
    {
        $this->layout = 'test';
        $this->view->params['t1'] = 'T1 params';
        $this->view->title = 'Test Page';
        $this->view->registerMetaTag(['name' => 'description', 'content' => 'мета-описание...'], 'description');

        $model = new EntryForm();

        $model->load(\Yii::$app->request->post());
        if (\Yii::$app->request->isAjax) {
            \Yii::$app->response->format = Response::FORMAT_JSON;
            if($model->validate()){
                return ['message' => 'ok'];
            }else{
                return ActiveForm::validate($model);
            }
            //return ActiveForm::validate($model);
        }

        return $this->render('index', compact('model'));
    }

    public function actionView()
    {
        $this->layout = 'test';
        $this->view->title = 'Работа с моделями';

//        $countries = Country::find()->all();
//        $countries = Country::find()->where("population < 100000000 AND code <> 'AU'")->all();
//        $countries = Country::find()->where("population < :population AND code <> :code", [':code' => 'AU', ':population' => 100000000])->all();
        /*$countries = Country::find()->where([
            'code' => ['DE', 'FR', 'GB'],
            'status' => 1,
        ])->all();*/
//        $countries = Country::find()->where(['like', 'name', 'ni'])->all();
//        $countries = Country::find()->orderBy('population DESC')->all();
//        $countries = Country::find()->count();
//        $countries = Country::find()->limit(1)->where(['code' => 'CN'])->one();
//        $countries = Country::findAll(['DE', 'FR', 'GB']);
//        $countries = Country::findOne('BR');
        $countries = Country::find()->asArray()->all();

        return $this->render('view', compact('countries'));
    }

    public function actionMyTest()
    {
        return $this->render('my-test');
    }

    public function actionCreate()
    {
        $this->layout = 'test';
        $this->view->title = 'Create';

        $country = new Country();

        if(\Yii::$app->request->isAjax){
            $country->load(\Yii::$app->request->post());
            \Yii::$app->response->format = Response::FORMAT_JSON;
            return ActiveForm::validate($country);
        }

        if($country->load(\Yii::$app->request->post()) && $country->save()){
            \Yii::$app->session->setFlash('success', 'OK');
            return $this->refresh();
        }

        /*$country->code = 'UA';
        $country->name = 'Ukraine';
        $country->population = 41840000;
        $country->status = 1;
        if($country->save()){
            \Yii::$app->session->setFlash('success', 'OK');
        }else{
            \Yii::$app->session->setFlash('error', 'OK');
        }*/

        return $this->render('create', compact('country'));
    }

}